/*#######################################################################################
AVR DCF77 Clock 

Copyright (C) 2005 Ulrich Radig

Modified 08/2005 Armin Diehl to support the Meinberg Protocol (Meinberg Standard-Zeittelegramm)
This protocol is supported by ntp (127.127.8.n mode 2), 9600 7E2

I have done this because i was not able to connect a simple connrad or reichelt receiver
with a simple opamp for the rs232 level conversion to work on my linux server. On another 
linux machine it worked. May be there is a hardware problem with the 50 baud receive used 
by ntpd (50 baud is also not supported on my thinkpad using xp, if i set 50 baud, it will 
use 75 baud)


#######################################################################################*/

#include "main.h"
#include <avr/sleep.h>


//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{
  unsigned char last_ss_counter = 0;
  char buf[34];
  unsigned char atLeastOneDCFSignalReceived = 0;
  unsigned char fail_counter = 0;  // in seconds
  unsigned char tellRxOk;

        DDRD = 0x0ff -8 -4 -2;                   // 6+7=Led, 5=U$7, 4,3=Jumper, 2=DCF IN (Int0), 1=TXD, 0=RXD
        PORTD = (1<<4)+(1<<3)+(1<<2);            // Activate Pullup for DCF and Jumper
	//Init Serial Interface
	UART_Init();

	//Switch Global Ints on
	sei();

	//and start the clock
	Start_Clock();

        //Normally you will not see this text because linux need some time
        //to load the usb drivers, reset the avr using the progheader to
        //see this text
	printf("\nDCF Module V1.0 Ready\nWaiting for DCF Signal\n");
	//Ausgabe der Zeit auf der Seriellen Schnittstelle in einer Endlosschleife
	while (1) {
		if (ss_counter != last_ss_counter) {  // wen Zeit geaendert wurde
		  //printf("%d-%d-%d Time: %d:%d:%d   %d     \r\n",day,mon,year,hh,mm,ss,rx_ok);
		  if (!atLeastOneDCFSignalReceived) atLeastOneDCFSignalReceived = rx_ok;
		  if (atLeastOneDCFSignalReceived) {
		    if (!rx_ok) fail_counter++;
		    else fail_counter = 0;
		    tellRxOk = 0;
		    if ((rx_ok) || (fail_counter < 181)) tellRxOk = 1;  // tell receive errors only if 3 minutes without signal, otherwise ntpd may get confused
  		    char sprung = ' ';
		    if (leapSecond) sprung = 'A';
		    else if (changeMEST_MET) sprung = '!';
		    // <STX>D:tt.mm.jj;T:w;U:hh.mm.ss;uvxy<ETX>
		    //               1         2         3
		    //      123456789012345678901234567890
		    //        x  x  x        x  x  x
		    sprintf (buf,"%cD:%2d.%2d.%2d;T:%d;U:%2d.%2d.%2d;%c%c%c%c%c",
	  	      0x02,                  // STX
		      day,mon,year-2000,
		      weekday,
		      hh,mm,ss,
		      tellRxOk ? ' ' : '#',
		      tellRxOk ? ' ' : '*',
		      MEST ? 'S' : ' ',
		      sprung,                // ' ': no, '!': summer/winter change 'A': Leap Second
		      0x03);                 // ETX
		                             // add leading zeros
		    if (buf[3] == ' ') buf[3] = '0';
		    if (buf[6] == ' ') buf[6] = '0';
		    if (buf[9] == ' ') buf[9] = '0';
		    if (buf[18] == ' ') buf[18] = '0';
		    if (buf[21] == ' ') buf[21] = '0';
		    if (buf[24] == ' ') buf[24] = '0';
		    printf (buf);
		    printf ("\r\n");
		    // if (tellRxOk) PORTB |= (1<<3); else PORTB &= ~(1<<3);  /* was for stk500 only */
		  }
		  last_ss_counter = ss_counter;
		  //hier sollte ich die cpu noch schlafen legen (idle mode)
		  //for (long i=0;i<20000000;i++){};
		  /*
		  To enter any of the five sleep modes, the SE bit in MCUCR must be written to logic one
		  and a SLEEP instruction must be executed. The SM2, SM1, and SM0 bits in the
		  MCUCR Register select which sleep mode (Idle, ADC Noise Reduction, Power-down,
		  Power-save, or Standby) will be activated by the SLEEP instruction.
		  */
		  // to be checked
		  //set_sleep_mode (SLEEP_MODE_IDLE);
		  //sleep_mode();
		}
	}
return (1);
}

