/*#######################################################################################
AVR DCF77 Clock 

Copyright (C) 2005 Ulrich Radig
Modified for dcf77usb by Armin Diehl (diehl@nordrhein.de)

#######################################################################################*/

#include "main.h"
#include "uart.h"

//############################################################################
//Routine fr die Serielle Ausgabe
int uart_putchar (char c)
//############################################################################
{
	if (c == '\n')
		uart_putchar('\r');
	//Warten solange bis Zeichen gesendet wurde
	loop_until_bit_is_set(USR, UDRE);
	//Ausgabe des Zeichens
	UDR = c;
	return (0);
}

//############################################################################
//Installation der Seriellen Schnittstelle (9600 7E2)
void UART_Init (void)
//############################################################################
{
	//Enable TXEN im Register UCR TX-Data Enable
	UCR=(1 << TXEN);
	//Teiler wird gesetzt 
	UBRR=(SYSCLK / (BAUD_RATE * 16L) - 1);
	
	UCSRC = (1<<URSEL)|
	        (1<<USBS)|   // 2 Stop Bits
		(2<<UCSZ0)|  // 7 Bit
		(1<<UPM1);   // Even
	
	//ffnet einen Kanal fr printf (STDOUT)
	fdevopen (uart_putchar, NULL, 0);
}

